require_relative "utils"

class Scrivener
  module Validations
    # Validates that an attribute is unique.
    #
    #   class User < Ohm::Model
    #     attribute :email
    #
    #     unique :email
    #   end
    #
    #   class SignUp < Scrivener
    #     attr_accessor :email
    #
    #     def validate
    #       assert_unique(:email, :User)
    #     end
    #   end
    #
    #   user = User.create(email: "mayn.kjaer@gmail.com")
    #   signup = SignUp.new(email: user.email)
    #   signup.valid? # => false
    #   signup.errors[:email] # => [:not_unique]
    #
    def assert_unique(att, model, error = [att, :not_unique])
      model = Utils.const(self.class, model)
      record = model.with(att, send(att))

      assert(record.nil?, error)
    end
  end
end
